
#include <iostream>
#include <map>
#include <string>

using namespace std;

class Player
{
public:
	const string name;

	inline Player(string name) : name(name) {}
	inline Player(const Player& player) : name(player.name) {}
	inline virtual ~Player(void) {}
};

class Players
{
public:
	inline Players(void) {}
	inline Players(const Players& plrs) {}
	inline ~Players(void) {}

	void addPlayer(const Player* p)
	{
		players[p->name] = p;
	}

	void removePlayer(const Player* p)
	{
		players.erase(p->name);
	}

	const Player* getPlayer(const string name) const
	{
		map<const string, const Player*>::const_iterator it;
		it = players.find(name);
		return (it != players.end()) ? it->second : NULL;
	}

private:
	map<const string, const Player*> players;
};

void test(const Players* p);
int main(int argc, char** argv)
{
	Players* p = new Players();
	p->addPlayer(new Player("cedric"));
	p->addPlayer(new Player("captain"));
	p->addPlayer(new Player("chipal"));
	test(p);
}

void test(const Players* p)
{
	//p->getPlayer("cedric");
	const Player* l = p->getPlayer("cedric");
	cout << "Player name : " << l->name << endl;
}


